package com.jeeplus.finance.contractRegistration.mapper;

import com.baomidou.mybatisplus.annotation.InterceptorIgnore;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.jeeplus.finance.contractRegistration.domain.ContractFile;
import com.jeeplus.finance.contractRegistration.domain.ContractInfo;
import com.jeeplus.sys.domain.WorkAttachmentInfo;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * @author: 王强
 * @create: 2022-11-08 10:47
 **/
//@InterceptorIgnore(tenantLine = "true")
public interface ContractInfoMapper extends BaseMapper<ContractInfo> {

    ContractInfo getInfoById(String id);

    ContractFile getById(String id);

    List<WorkAttachmentInfo> findDtos(@Param("id") String id);

    IPage<ContractInfo> findPageList(Page<ContractInfo> page, @Param("officeIds") String officeIds, @Param(Constants.WRAPPER) QueryWrapper queryWrapper);

    // 新增方法（指定用户用，忽略数据权限）
    @InterceptorIgnore(dataPermission = "true") // ✅ 官方原生注解，只忽略数据权限
    IPage<ContractInfo> findPageListNoDataPerm(Page<ContractInfo> page, @Param("officeIds") String officeIds, @Param(Constants.WRAPPER) QueryWrapper<ContractInfo> wrapper);

    ContractInfo findById (@Param("id") String id);

    ContractInfo findFileInfoById (@Param("id") String id);

    ContractInfo findByContractId (@Param("id") String id);

    void updateStatusById(@Param("id") String id, @Param("status")String status);

    void updatefiledTypeById(@Param("id") String id, @Param("status")String status);

    void updatefiledPaperTypeById(@Param("id") String id, @Param("status")String status);

    List<WorkAttachmentInfo> findList(@Param("id") String id);

    /**
     * 根据AttachmentFla 和AttachmentId 查询附件信息
     * @param id
     * @param attachmentFlag
     * @return
     */
    List<WorkAttachmentInfo> findListByIdAndAttachmentFlag(@Param("id") String id, @Param("attachmentFlag")String attachmentFlag);

    Integer findIsExit(@Param("id") String id, @Param("name")String name);

    Integer findByUrlIsExit(@Param("id") String id, @Param("url")String url);

    /**
     * 修改合同实际金额
     * @param id
     * @param actualContractAmount
     * @param contractApprovalType
     */
    void updateInfo(@Param("id") String id,
                    @Param("actualContractAmount") Double actualContractAmount,
                    @Param("contractApprovalType") String contractApprovalType,
                    @Param("filedType") String filedType);

    List<String> findChildIds(String department);

    List<ContractInfo> getByClientId(@Param(Constants.WRAPPER) QueryWrapper queryWrapper);

    // 没有使用客户id作为参数，而是直接查询，是因为 合同与客户的关联表 中没有 客户id 的字段，只有客户编号的字段
    List<String> getClientListByClientNo(@Param("no") String no);

    void updateBorrowTypeById(@Param("id") String id, @Param("status")String status);

    /**
     * 修改纸质归档状态
     * @param id
     * @param filedPaperType
     */
    void updatePaperInfo(@Param("id") String id,
                         @Param("actualContractAmount") Double actualContractAmount,
                         @Param("contractApprovalType") String contractApprovalType,
                         @Param("filedPaperType") String filedPaperType);

    String isUseByProject(@Param("id") String id);

    String isUseByReim(@Param("id") String id);

    String isUseByInvoice(@Param("id") String id);

    /**
     * 根据合同名称查询合同信息
     * @param contractNameList
     * @return
     */
    List<ContractInfo> getByContractNameList(@Param("contractNameList") List<String> contractNameList, @Param("userId") String userId);

    /**
     * 项目登记时，查询所有合同
     * @return
     */
    IPage<ContractInfo> projectRegContractList(Page<ContractInfo> page, @Param("officeIds") String officeIds, @Param(Constants.WRAPPER) QueryWrapper queryWrapper);

    Integer updateContractNameAndClient(@Param("id") String id, @Param("contractName") String contractName, @Param("clientId") String clientId);
}
